#ifndef EINDIGEELEMENT_H
#define EINDIGEELEMENT_H

#include <math.h>
#include "matriks.h"

typedef enum { vals, waar } bools;

matriks EindigeElementK1D (double l, int n, double q,
  bools links0, bools regs0);
  
matriks EindigeElementM1D (double l, int n, bools links0, bools regs0);

struct node2dTipe {
  double x, y;
  bools nul; // Is gedwonge randvoorwaardes van toepassing ?
};

struct element2d {
  int   i[3]; // Driehoek ! Indekse in die node skikking in.
  double laplaceKoef, uKoef;
  char *krag; // f. Die krag wat oor die element
  double kleur[3]; // Wys na 'n double[3]. Werk direk saammet glColor3dv()
};

struct rand2d {
  double x, y, deltax, deltay;
  double normDelta; // As die lyn net 'n punt is, kook ons normDelta
  double gradKoef, uKoef; // Koe"ffisie"nte van \\nabla u \cdot n en u
  char *waarde; // Wys na die deel net na die gelyk aan teken.
};

#define MAKS_FIG_KLEURE 70 // Max colors in a fig file.
struct verdeling2d {
  int nnodes, ndriehoeke, nrande;
  node2dTipe *node;
  element2d *dh;
  rand2d *rand;
  matriks K, M;
  vektor F; // \int_0^\ell f_I \phi_i dx
  // As f diskontinu is, bestaan f_I nie in die gewone sin nie en M*f != F
  char *effek[MAKS_FIG_KLEURE+1]; // Gebruik kleure -1 tot MAKS met xfig.
};

void EindigeElementPoisson (verdeling2d &v);

void MaakInverteerbaar (matriks m, verdeling2d &v); // 'n Ou funksie

verdeling2d Verfyning (verdeling2d &v, int ekstraNodes);

void LeesFig (char *leerNaam, verdeling2d &v, bools nulOpRant,
 void (*hanteerMerker)(char *merk, double x, double y, verdeling2d &v)=NULL);
// hanteerMerker word vir elke teks veld geroep wat LeesFig nie self hanteer
// nie (wat nie met $ begin nie)

#endif

